
#ifndef PLS_SPINLOCK_H
#define PLS_SPINLOCK_H

#include <atomic>

#include "pls/internal/base/thread.h"

namespace pls {
    namespace internal {
        namespace base {
            class spin_lock {
                std::atomic_flag flag_;
                int yield_at_tries_;


            public:
                spin_lock(): flag_{ATOMIC_FLAG_INIT}, yield_at_tries_{1024} {};

                void lock() {
                    int tries = 0;
                    while (flag_.test_and_set(std::memory_order_acquire)) {
                        tries++;
                        if (tries % yield_at_tries_ == 0) {
                            this_thread::yield();
                        }
                    }
                }
            };
        }
    }
}

#endif //PLS_SPINLOCK_H
